﻿@model RealEstate.Models.AttendenceModel
@{
    ViewBag.Title = "Attendence";
    Layout = "~/Views/Shared/_Layout.cshtml";
}
<style>
    table.dataTable thead th, table.dataTable thead td {
        padding: 0px 0px !important;
        border-bottom: 0px solid #111 !important;
    }

    table.dataTable tbody th, table.dataTable tbody td {
         
        padding: 0px 0px;
    }

    .P {
        background-color: #c8ffc5
    }

    .A {
        background-color: #e89797
    }

    .H {
        background-color: #c189ec
    }

    .L {
        background-color: #e9ea85
    }
</style>


@using (@Html.BeginForm("Index", "Attendence", FormMethod.Post))
{
    <div class="row">

        <div class="col-xl-4 col-md-4 ">
            <div class="card text-white mb-1">
                <div class="card-body text-center">
                    <div class="form-group">
                        <div class="col-md-4 float-right">
                            <button class="btn btn-danger" type="submit" onclick="RemoveDatatable();">SAVE</button>
                        </div>

                        <div class="col-md-6">
                            @Html.EditorFor(model => model.month_year, new { htmlAttributes = new { @class = "form-control monthpicker", autocomplete = "off" } })
                            @Html.ValidationMessageFor(model => model.month_year, "", new { @class = "text-danger" })
                        </div>
                    </div>
                </div>
                @*<div class="card-footer text-center">
                    </div>*@
            </div>
        </div>


        <div class="col-xl-3 col-md-4 ">
            <a href="/Attendence/AttendenceList/" title="View Details">
                <div class="card bg-primary text-white mb-1">
                    <div class="card-body text-center">Total Employees</div>
                    <div class="card-footer text-center" id="totaluser">
                        @Model.total_employee
                    </div>
                </div>
            </a>
        </div>
        
        <div class="col-xl-3 col-md-4">
            <a href="/Attendence/LeaveRequest" title="View Details">
                <div class="card bg-unapproved-leave text-white mb-1">
                    <div class="card-body text-center">Leave Request</div>
                    <div class="card-footer text-center" id="Leaverequest">
                        @Model.leave_request
                    </div>
                </div>
            </a>
        </div>


    </div>


    <div class="row">
        <div class="col-xl-12 ">
            <div class="card bg-default text-black mb-1">
                <div class="card-body text-center" style="overflow:auto">
                    <div class="datatable table-responsive">
                        <div id="dataTable_wrapper" class="dataTable_wrapper dt-bootstrap4">
                            <div class="col-sm-12">

                                <div class="text-center" style="width:25%">
                                    @{
                                        var projectLst = new List<string>();

                                        foreach (var x in Model.Users)
                                        {
                                            foreach (var y in x.UserProjects)
                                            {
                                                projectLst.Add(y.MA_Project.ProjectName);
                                            }
                                        }
                                        projectLst = projectLst.Distinct().OrderBy(x => x).ToList();

                                        <select class="form-control" id="dd_search">
                                            <option value="">---All Project---</option>
                                            @foreach (var x in projectLst)
                                            {
                                                <option>@x</option>
                                            }
                                        </select>
                                    }
                                </div>

                                <p>
                                    <table class="table" id="dt_attendence">
                                        <thead>
                                            <tr>
                                                <th scope="col">NAME</th>
                                                <th scope="col">Project</th>
                                                @for (int i = 1; i <= Model.total_days; i++)
                                                {
                                                    <th scope="col">@i</th>
                                                }

                                            </tr>
                                        </thead>
                                        <tbody>
                                            @foreach (var usr in Model.Users)
                                            {
                                                <tr>

                                                    <td style="color: blue; text-align:left"><a href="/User/AddEditUser/@usr.Id">@usr.Name</a></td>
                                                    <td style="text-align:left">@String.Join(",", usr.UserProjects.Select(x => x.MA_Project.ProjectName))</td>


                                                    @for (int k = 1; k <= Model.total_days; k++)
                                                    {
                                                        var value = "";
                                                        try
                                                        {
                                                            value = usr.UserAttendences.ToArray()[k - 1].Value;
                                                            <td><input type="text" class="@value" value="@value" id="@string.Join("~", usr.Id.ToString(), k.ToString())" name="@string.Join("~", usr.Id.ToString(), k.ToString())" style="width:25px;"></td>
                                                        }
                                                        catch
                                                        {
                                                            <td><input type="text" value="" id="@string.Join("~", usr.Id.ToString(), k.ToString())" name="@string.Join("~", usr.Id.ToString(), k.ToString())" style="width:25px;"></td>
                                                        }
                                                    }
                                                </tr>
                                            }
                                        </tbody>
                                    </table>
                                </p>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>

}
@*<div class="row">
        <div class="col-xl-4 col-md-6">
            <div class="card bg-default text-black mb-1">
                <div class="card-body text-center">
                    <select class="form-control" id="ddluser">
                    </select>
                </div>
            </div>
        </div>
    </div>*@

@*<div class="row">
        <div class="col-xl-12 ">
            <div class="card bg-default text-black mb-1">
                <div class="card-body text-center">
                    <div id="AdminCalendar"></div>
                </div>
            </div>
        </div>
    </div>*@



<script type="text/javascript">
     

    $(function () {


        var mydatatable = $('#dt_attendence').DataTable({
            "pagingType": "full_numbers"
        });


        $('#dd_search').change(function () {
            mydatatable.search(this.value).draw();
        });

    })




    $('.monthpicker').MonthPicker({
        MinMonth: -12, Button: false, MonthFormat: 'M yy', OnAfterChooseMonth: function () {
            showloader(true)
            window.location.href = "/Attendence/Index?month_year=" + $(this).val();
        } });

    @*
        var data = {
            UserId: "",
            IsPresent: false,
            Date: "",
            Remarks: "",
            Location: "Admin Office",
            LeaveId: null,
            IsApproved: null
        };
        var MA_Leave_Lst_Arr;
        var MA_Leave_Lst;

        $(document).ready(function () {
            getAllUser();
        });


        function getAllUser(userid) {
            $.ajax({
                url: '/Attendence/GetAllUserAttendence/',
                type: "GET",
                dataType: "JSON",
                success: function (result) {
                    $("#ddluser").empty()
                    $("#totaluser").text(result.TotalUser);
                    $("#present").text(result.Present);
                    $("#absent").text(result.Absent);
                    $("#Leaverequest").text(result.Leaverequest);



                    $.each(result.Users, function (key, value) {
                        $("#ddluser").append($("<option></option>").val(value.Id).html(value.Name));
                    });

                    if (userid != undefined)
                        $('#ddluser').val(userid);
                    data.UserId = $('#ddluser').find(":selected").val().trim();

                    //Append list of list to dropdown
                    MA_Leave_Lst_Arr = _.where(result.MA_Leave_Lst, { IsPaid: false })
                    MA_Leave_Lst = "<option value='0'>---Select Leave Code---</option>"
                    var user_leave_option = _.filter(result.MA_Leave_Lst, function (leave) {
                        return leave.IsPaid != false;
                    });
                    $.each(user_leave_option, function (key, value) {
                        MA_Leave_Lst += "<option value=" + value.Id + ">" + value.Name + "</option>";
                    });

                    LoadCalender();
                }
            });
        }

        $("#ddluser").change(function () {
            data = {
                UserId: $(this).val(),
                IsPresent: false,
                Date: "",
                Remarks: "",
                Location: "Admin Office",
                LeaveId: null,
                IsApproved: null
            };
            $('#AdminCalendar').fullCalendar('prev');
            $('#AdminCalendar').fullCalendar('next');
        })

        function LoadCalender() {
            $('#AdminCalendar').fullCalendar({
                header:
                {
                    left: 'prev,next today',
                    center: 'title',
                    right: 'month'//',agendaWeek,agendaDay'
                },
                buttonText: {
                    today: 'Today',
                    month: 'Month',
                    //week: 'week',
                    //day: 'day'
                },
                events: function (start, end, timezone, callback) {
                    $.ajax({
                        url: '/Attendence/GetAttendence?UserId=' + data.UserId,
                        type: "GET",
                        dataType: "JSON",
                        success: function (result) {
                            var events = [];


                            //--------------User Holiday----------------
                            $.each(result.UserAttendences, function (i, data) {
                                var d = new Date(parseInt(data.Date.substr(6)));
                                var formatted_date = moment([d.getFullYear(), (d.getMonth() + 1), d.getDate()].join('-')).format('YYYY-MM-DD')
                                events.push(
                                    {
                                        title: data.Leave_Name,
                                        description: "Location : " + data.Location + " </br></br>Remarks: " + data.Remarks,
                                        start: formatted_date,
                                        end: formatted_date,
                                        backgroundColor: "#fff",
                                        borderColor: "none",
                                        className: data.IsPresent ? ["bg-success"] : data.IsApproved == null ? ["bg-unapproved-leave"] : data.IsApproved ? ["bg-absent"] : ["bg-rejected-leave"]
                                    });
                            });

                            //--------------Company Holiday----------------
                            $.each(MA_Leave_Lst_Arr, function (i, data) {

                                var start = new Date(parseInt(data.FromDate.substr(6)));
                                var formatted_start = moment([start.getFullYear(), (start.getMonth() + 1), start.getDate()].join('-')).format('YYYY-MM-DD')
                                var end = new Date(parseInt(data.ToDate.substr(6)));
                                var formatted_end = moment([end.getFullYear(), (end.getMonth() + 1), end.getDate()].join('-')).format('YYYY-MM-DD')

                                events.push(
                                    {
                                        title: data.Name,
                                        description: data.Name,
                                        start: formatted_start,
                                        end: formatted_end,
                                        backgroundColor: "#ffff",
                                        borderColor: "none",
                                        className: ["bg-primary"]
                                    });
                            });

                            //------------load data of first selected user-----
                            callback(events);
                            getAllUser(data.UserId)
                        }
                    });
                },
                eventRender: function (event, element) {
                    element.qtip(
                        {
                            content: event.description
                        });
                },
                eventClick: function (calEvent, jsEvent, view) {
                    data.Date = calEvent.start._i;
                    OpenPopUp(data, $(this));
                },
                dayClick: function (date, jsEvent, view) {
                    data.Date = date.format();
                    OpenPopUp(data, $(this))
                },
                dayRender: function (date, cell) {
                    cell.css("background", "#ffffff");
                    //var data = User_Attendence_Data;
                    //var today = $.fullCalendar.moment();
                    //var end = $.fullCalendar.moment().add(1, 'days');
                    //if (date.get('date') == today.get('date')) {
                    //    cell.css("background", "blue");
                    //}
                },
                editable: false
            });
        }

        function OpenPopUp(data, e) {
            var date = data.Date;
            //if ((new Date().getMonth() + 1 != new Date(date).getMonth() + 1) || (new Date().getFullYear() != new Date(date).getFullYear())) {
            //    return;
            //}

            $.confirm({
                closeIcon: true,
                closeIconClass: 'fa fa-close',
                //autoClose: 'cancel|800000',
                title: 'Mark Present ?',
                content: '' +
                    '<form action="" class="formName">' +
                    '<div class="form-group">' +
                    '<select class="leave form-control">' + MA_Leave_Lst + '<select></br>' +
                    '<input type="text" placeholder="Remarks" class="name form-control" />' +
                    '</div>' +
                    '</form>',
                buttons: {
                    formSubmit: {
                        text: 'Present',
                        btnClass: 'btn-success',
                        action: function () {
                            data.Remarks = this.$content.find('.name').val();
                            data.IsPresent = true;
                            data.LeaveId = null;
                            //$(e).css('background-color', '#28a745');
                            SetAttendence(data);
                        }
                    },

                    ApplyForLeave: {
                        text: 'ABSENT',
                        btnClass: 'btn-danger',
                        // keys: ['enter', 'shift'],
                        action: function () {
                            data.LeaveId = this.$content.find('.leave option:selected').val();
                            if (data.LeaveId == 0) {
                                alert("Select leave code to proceed")
                                return false;
                            }
                            data.Remarks = this.$content.find('.name').val();
                            data.IsPresent = false;
                            data.IsApproved = true;
                            SetAttendence(data);
                        }
                    },
                    cancel: {
                        btnClass: 'btn-primary'
                    },
                },
                onContentReady: function () {
                    // bind to events
                    var jc = this;
                    this.$content.find('form').on('submit', function (e) {
                        // if the user submits the form by pressing enter in the field.
                        e.preventDefault();
                        jc.$$formSubmit.trigger('click'); // reference the button and click it
                    });
                }
            });
        }
        function getLocation(data) {

            if (navigator.geolocation) {
                navigator.geolocation.getCurrentPosition(Get_Location_Name, showError);
            } else {
                data.Location = "Geolocation is not supported by this browser.";
                SetAttendence(data)
            }
        }
        function showError(error) {
            switch (error.code) {
                case error.PERMISSION_DENIED:
                    $.notify("Your geolocation is disabled. Enable it to capture location.", 'info');
                    data.Location = "Geolocation Disabled";
                    SetAttendence(data)
                    //var resp = confirm("Proceed without geolocation.")
                    //if (resp == true) {
                    //    data.Location = "Geolocation Disabled";
                    //    SetAttendence(data)
                    //} else {
                    //    $('#AdminCalendar').fullCalendar('prev');
                    //    $('#AdminCalendar').fullCalendar('next');
                    //}
                    break;
                case error.POSITION_UNAVAILABLE:
                    alert("Location information is unavailable.")
                    break;
                case error.TIMEOUT:
                    alert("The request to get user location timed out.")
                    break;
                case error.UNKNOWN_ERROR:
                    alert("An unknown error occurred.")
                    break;
            }
        }
        function Get_Location_Name(position) {
            $.ajax({
                url: 'https://api.opencagedata.com/geocode/v1/json?q=' + position.coords.latitude + '+' + position.coords.longitude + '&key=d3431fc7c75e46beb78e54d0a390b337',
                type: "GET",
                dataType: "JSON",
                success: function (result) {
                    if (result.status.code == 200) {
                        data.Location = result.results[0].formatted
                    }
                    SetAttendence(data)
                },
                error: function () {
                    SetAttendence(data)
                }
            });
        }
        function SetAttendence(data) {
            showloader(true);
            $.ajax({
                url: '/Attendence/SetAttendence?IsAdmin=1',
                type: "POST",
                dataType: "JSON",
                data: data,
                success: function (result) {
                    showloader(false);
                    $.notify(result.Data, 'info');
                    $('#AdminCalendar').fullCalendar('prev');
                    $('#AdminCalendar').fullCalendar('next');
                    // $('#AdminCalendar').fullCalendar('refetchEvents');
                },
                error: function (jqXHR, exception) {
                    showloader(false);
                    $.notify("Some error occured, contact administrator", 'info');
                }
            });
        }
        *@


</script>